stages:
  - test
  - build
  - deploy

image: registry.gitlab.com/pantacor/dockerbuilder:master

services:
  - docker:dind

variables:
  CONTAINER_IMAGE: registry.gitlab.com/$CI_PROJECT_PATH
  DOCKER_DRIVER: overlay2
  GIT_SUBMODULE_STRATEGY: recursive

test:
  stage: test
  script:
    - make test
  after_script:
    - make clean

build-branch:
  stage: build
  before_script:
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN registry.gitlab.com
    - docker run --rm --privileged multiarch/qemu-user-static:register || true
  script:
    - docker pull $CONTAINER_IMAGE:$CI_COMMIT_REF_SLUG || true
    - docker build -f Dockerfile --cache-from $CONTAINER_IMAGE:$CI_COMMIT_REF_SLUG --tag $CONTAINER_IMAGE:$CI_COMMIT_REF_SLUG-$CI_COMMIT_SHORT_SHA --tag $CONTAINER_IMAGE:$CI_COMMIT_REF_SLUG .
    - test -n "$CI_BUILD_TAG" && docker tag $CONTAINER_IMAGE:$CI_COMMIT_REF_SLUG-$CI_COMMIT_SHORT_SHA $CONTAINER_IMAGE:$CI_BUILD_TAG || true
    - docker push $CONTAINER_IMAGE:$CI_COMMIT_REF_SLUG-$CI_COMMIT_SHORT_SHA
    - docker push $CONTAINER_IMAGE:$CI_COMMIT_REF_SLUG
    - test -n "$CI_BUILD_TAG" && docker push $CONTAINER_IMAGE:$CI_BUILD_TAG || true
  except:
  - develop
  - master

build-devel:
  stage: build
  before_script:
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN registry.gitlab.com
    - docker run --rm --privileged multiarch/qemu-user-static:register || true
  script:
    - docker pull $CONTAINER_IMAGE:$CI_COMMIT_REF_SLUG || true
    - docker build -f Dockerfile --cache-from $CONTAINER_IMAGE:$CI_COMMIT_REF_SLUG --tag $CONTAINER_IMAGE:$CI_COMMIT_REF_SLUG-$CI_COMMIT_SHORT_SHA --tag $CONTAINER_IMAGE:$CI_COMMIT_REF_SLUG .
    - test -n "$CI_BUILD_TAG" && docker tag $CONTAINER_IMAGE:$CI_COMMIT_REF_SLUG-$CI_COMMIT_SHORT_SHA $CONTAINER_IMAGE:$CI_BUILD_TAG || true
    - docker push $CONTAINER_IMAGE:$CI_COMMIT_REF_SLUG-$CI_COMMIT_SHORT_SHA
    - docker push $CONTAINER_IMAGE:$CI_COMMIT_REF_SLUG
    - test -n "$CI_BUILD_TAG" && docker push $CONTAINER_IMAGE:$CI_BUILD_TAG || true
  only:
  - develop

build-master:
  stage: build
  before_script:
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN registry.gitlab.com
    - docker run --rm --privileged multiarch/qemu-user-static:register || true
  script:
    - docker pull $CONTAINER_IMAGE:$CI_COMMIT_REF_SLUG || true
    - docker build -f Dockerfile --cache-from $CONTAINER_IMAGE:$CI_COMMIT_REF_SLUG --tag $CONTAINER_IMAGE:$CI_COMMIT_REF_SLUG-$CI_COMMIT_SHORT_SHA --tag $CONTAINER_IMAGE:$CI_COMMIT_REF_SLUG .
    - test -n "$CI_BUILD_TAG" && docker tag $CONTAINER_IMAGE:$CI_COMMIT_REF_SLUG-$CI_COMMIT_SHORT_SHA $CONTAINER_IMAGE:$CI_BUILD_TAG || true
    - docker push $CONTAINER_IMAGE:$CI_COMMIT_REF_SLUG-$CI_COMMIT_SHORT_SHA
    - docker push $CONTAINER_IMAGE:$CI_COMMIT_REF_SLUG
    - test -n "$CI_BUILD_TAG" && docker push $CONTAINER_IMAGE:$CI_BUILD_TAG || true
  only:
  - master
